#include <bits/stdc++.h>

using namespace std;

#define int long long

void bfs(int start, vector<vector<int>>& a, vector<int>& dist, int range) {
    queue<int> q;
    q.push(start);
    dist[start] = 0;

    while (!q.empty()) {
        int current = q.front();
        q.pop();

        if (dist[current] == range) {
            continue;
        }

        for (int neighbor : a[current]) {
            if (dist[neighbor] == -1) {
                dist[neighbor] = dist[current] + 1;
                q.push(neighbor);
            }
        }
    }
}

signed main() {
    int n, m, k; 
    cin >> n >> m >> k;

    if (k == 0) {
        return 0;
    }

    vector<vector<int>> a(n);

    for (int i = 0; i < m; i++) {
        int a1, b;
        cin >> a1 >> b;
        a1--; b--;
        a[a1].push_back(b);
        a[b].push_back(a1);
    }

    vector<int> protecte(k);
    vector<int> range(k);

    for (int i = 0; i < k; i++) {
        cin >> protecte[i];
        cin >> range[i];
        protecte[i]--;
    }

    vector<int> dist(n, -1);

    for (int i = 0; i < k; i++) {
        bfs(protecte[i], a, dist, range[i]);
    }

    vector<int> protected_nodes;

    for (int i = 0; i < n; i++) {
        if (dist[i] != -1) {
            protected_nodes.push_back(i);
        }
    }

    cout << protected_nodes.size() << endl;

    for (int i = 0;i < protected_nodes.size();i++) {
        cout << i + 1 << " ";
    }
    cout << endl;

    return 0;
}